#include <stdio.h>
#include <stdlib.h>
#include "siftop.h"
#include "abc.h"

siftop Top;

int main (int argc,char *argv[])
{
  XFILE *in;
  FILE *out;
  long j=0;
  long i,w,z,l,h,k=0;
  long **edges;
  long ****edgenod;
  long *edgdiv;       // pole, kde je ulozeno deleni kazde krajni hrany v jedne topologii(rezu)
  long ***elemdiv;
  long numcuts;       // pocet char. rezu
  long numel=0,numnod=0;
  long numsec,dn;
  double zetko=0.0;
  double *pom;
  section *arsec;
  siftop *cuts;       // pole siftopu, kde jsou ulozeny zadane charakteristicke rezy
  siftop *topcuts;    // pole siftopu, do ktereho jsou vygenerovany charakteristicke rezy

 

  fprintf(stdout, "\n\n\n---          GENERATOR OF STRUCTURED MESH             ---\n");
  if (argc < 3){
    fprintf (stderr,"\n Wrong number of command line parameters.");
    fprintf (stderr,"\n Use : %s input_file_name output_file_name \n\n", argv[0]);
    return(1);
  }
  in = xfopen(argv[1], "rt");
  if (in==NULL)
  {
    fprintf (stderr,"\n Output file has not been specified.");
    fprintf (stderr,"\n Try it again!\n\n");
    return(2);
  }
  out = fopen(argv[2], "wt");
  if (out==NULL)
  {
    fprintf (stderr,"\n Output file has not been specified.");
    fprintf (stderr,"\n Try it again!\n\n");
    return(2);
  }

  read (in,edgdiv,arsec,cuts,numcuts,topcuts,numsec); // cteni ze souboru
  alloc (edges,elemdiv,numcuts,cuts);  // alokovani edges a elemdiv

/*
Nasledujic cyklus:
- spocita, kolik bude uzlu a elementu v nasledne vygenerovanych charakteristickych rezech
- naplni pole elemdiv, ktere udava deleni na hranach v makroelementech z jednotlivych char. rezu
*/
  for (w=0;w<numcuts;w++)
  {
    for (i=0;i<cuts[w].ne;i++)
    {
      searchsimedg(cuts[w].elements,i,edges);
      div_elements (edgdiv,elemdiv[w],cuts[w].elements[i].propedg,edges,i);
      topcuts[w].ne += elemdiv[w][i][0]*elemdiv[w][i][1];
      topcuts[w].nn += (elemdiv[w][i][0]+1)*(elemdiv[w][i][1]+1);
    }
  }

  edgenod = new long***[numcuts];
  for (h=0;h<numcuts;h++)
  {
    edgenod[h] = new long**[cuts[h].ne];
    for (i=0;i<cuts[h].ne;i++)
    {
      edgenod[h][i]= new long*[4];
      for (w=0;w<4;w++)
      {
        edgenod[h][i][w] = new long [elemdiv[h][i][w]+1];
        for (z=0;z<(elemdiv[h][i][w]+1);z++) edgenod[h][i][w][z]=-1;
      }
    }
  }
  for (h=0;h<numcuts;h++)               // alokovani pole siftopu topcuts
  {
    topcuts[h].nodes = new snode[topcuts[h].nn];
    topcuts[h].elements = new selement[topcuts[h].ne];
    for (i=0;i<topcuts[h].ne;i++)
    {
      topcuts[h].elements[i].type = isolinear2d;
      topcuts[h].elements[i].alloc(1);
    }
  }

  for (w=0;w<numcuts;w++)           // vygenerovani vsech char. rezu/naplneni pole topcuts
  {
    l=0;j=0;k=0;
    for (i=0;i<cuts[w].ne;i++)
    {
      l=j;
      searchsimedg(cuts[w].elements,i,edges);
      gennodes(elemdiv[w][i][0],elemdiv[w][i][1],cuts[w].nodes,cuts[w].elements[i].nodes,topcuts[w].nodes,j,edges,edgenod[w],i);
      genelements(elemdiv[w][i][0],elemdiv[w][i][1],cuts[w].elements[i].propedg,cuts[w].elements[i].propsurf,topcuts[w].elements,edgenod[w][i],edges,l,k);
    }
    topcuts[w].nn=j;
  }

  Top.ne=0;Top.nn=0;
  for (i=0;i<numsec;i++)
  {
    dn = (topcuts[arsec[i].a].nn) - (topcuts[arsec[i].b].nn);
    if (dn <= 0)
    {
      Top.ne+=(arsec[i].division+1)*topcuts[arsec[i].a].ne;
      Top.nn+=(arsec[i].division+1)*topcuts[arsec[i].a].nn;
    }
    else
    {
      Top.ne+=(arsec[i].division+1)*topcuts[arsec[i].b].ne;
      Top.nn+=(arsec[i].division+1)*topcuts[arsec[i].b].nn+dn;
    }
  }
  Top.nn+=topcuts[arsec[numsec-1].b].nn;

  pom = new double[Top.nn];  
  Top.nodes = new snode[Top.nn];
  Top.elements = new selement[Top.ne];
  for (i=0;i<Top.ne;i++)
  {
    Top.elements[i].type = isolinear3d;
    Top.elements[i].alloc(1);
  }

  for (i=0;i<numsec;i++)     // generovani useku
    gensection (arsec[i],topcuts,Top,numel,numnod,zetko);

  for (i=0;i<Top.nn;i++)
  {
    pom[i]         = Top.nodes[i].y;
    Top.nodes[i].y = Top.nodes[i].x;
    Top.nodes[i].x = Top.nodes[i].z;
    Top.nodes[i].z = pom[i];
  }
  
  Top.print(out);
  fclose(out);
  scanf("%*c"); 
  return 0;
}

