#ifndef CTLINTERFACE_H
#define CTLINTERFACE_H


#include <vector>
#include <string>

class Ctlinterface
{
 public:
  Ctlinterface();
  Ctlinterface(const std::string& input);
  Ctlinterface( const std::string& input, const std::vector<double>& params );
  ~Ctlinterface();

  void set_params( const std::vector<double>& params );
  int solve();
  void get_state( std::vector<double>& state ) const;
  void get_residual(const std::vector<double>& params,const std::vector<double>& state, const unsigned int niter, std::vector<double>& residual ) const;
  
};

#endif
